/* Demonstration Program for TK-78K0/KF2 */
/* (UPD78F0547: 78K0/KF2)                */
/*   main.c                              */
/*   initial.c                           */
/*   interrupt.c                         */

/*********************************************************/
/*********************************************************/

#pragma interrupt INTTM000 	inttm000
#pragma interrupt INTP1		intp1
#pragma interrupt INTWT		intwt

#include "common.h"


unsigned char	g_start;
unsigned char 	g_led = 0;
unsigned char	g_count = 0;
unsigned char	g_led_s = 0;


/*********************************************************/
/*********************************************************/
void inttm000(void)
{

	g_count++;
	if (g_count == 10) {
		g_count = 0;
	}

	switch( g_led ) {// 76543210
		case 0 : P5 = 0b11111110;
				 break;
		case 1 : P5 = 0b11111101;
				 break;
		case 2 : P5 = 0b11111011;
				 break;
		case 3 : P5 = 0b11110111;
				 break;
		case 4 : P5 = 0b11101111;
				 break;
		case 5 : P5 = 0b11011111;
				 break;
	}

	g_led++;
	if (g_led == 6)
		g_led = 0;
	g_led_s += (char)( g_start == 2 );
}


/******************************************************/
/******************************************************/
void intp1(void)
{
	g_start = 1;
}

/******************************************************/
/******************************************************/

int wt;

void intwt(void)
{
	if (wt!=0) {
		P5 = 0x7f;
		wt = 0;
	} else {
		switch( g_count ) {
			case 0 : P5 = DISP_0 & 0x7f;
					 break;
			case 1 : P5 = DISP_1 & 0x7f;
					 break;
			case 2 : P5 = DISP_2 & 0x7f;
					 break;
			case 3 : P5 = DISP_3 & 0x7f;
					 break;
			case 4 : P5 = DISP_4 & 0x7f;
					 break;
			case 5 : P5 = DISP_5 & 0x7f;
					 break;
			case 6 : P5 = DISP_6 & 0x7f;
					 break;
			case 7 : P5 = DISP_7 & 0x7f;
					 break;
			case 8 : P5 = DISP_8 & 0x7f;
					 break;
			case 9 : P5 = DISP_9 & 0x7f;
					 break;
		}
		wt = 1;
	}
}

